<?php 
/**
 * Система управления сайтом HostCMS v. 5.xx
 * Copyright © 2005-2010 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 *
 * Ajax загрузчик формы списка городов.
 * 
 * Файл: /admin/shop/action/load_city.php
 * 
 * @author Hostmake LLC
 * @version 5.x
 */
function LoadAjaxData(&$admin_forms)
{
	$on_page = $admin_forms->GetOnPageCount();

	$page = to_int($_REQUEST['limit']);
	$begin = ($page == 0) ? 0 : ($page - 1) * $on_page;

	$param = array();

	$param['limit'][0] = array('begin' => $begin, 'count' => $on_page);

	$shop_country_id = to_int($_REQUEST['shop_country_id']);

	$shop_location_id = to_int($_REQUEST['shop_location_id']);

	$DataBase = & singleton('DataBase');

	$shop = new shop();

	$country_row = $shop->GetCountry($shop_country_id);

	$row = $shop->GetLocation($shop_location_id);

	$param['title'] = $GLOBALS['MSG_shops']['show_city_title'].' "'.$row['shop_location_name'].'"';

	// Строим хлебные крошки.
	$array = array();
	$array['name'] = $GLOBALS['MSG_shops']['header_admin__list_forms'];
	$array['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/shop/shop.php', '', 54, 'load_data');
	$array['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/shop/shop.php', '', 54, 'load_data');
	$param['path_array'][] = $array;

	$array = array();
	$array['name'] = $GLOBALS['MSG_shops']['country_add_form_link1'];
	$array['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/shop/shop.php', '', 58, 'load_data');
	$array['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/shop/shop.php', '', 58, 'load_data');
	$param['path_array'][] = $array;

	$array = array();
	$array['name'] = $GLOBALS['MSG_shops']['show_location_title'].' "'.$country_row['shop_country_name'].'"';
	$array['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/shop/shop.php', "&shop_country_id=$shop_country_id", 59, 'load_data');
	$array['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/shop/shop.php', "&shop_country_id=$shop_country_id", 59, 'load_data');
	$param['path_array'][] = $array;

	$array = array();
	$array['name'] = $GLOBALS['MSG_shops']['show_city_title'].' "'.$row['shop_location_name'].'"';
	$array['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/shop/shop.php', "&shop_country_id=$shop_country_id&shop_location_id=$shop_location_id", 60, 'load_data');
	$array['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/shop/shop.php', "&shop_country_id=$shop_country_id&shop_location_id=$shop_location_id", 60, 'load_data');
	$param['path_array'][] = $array;

	// Выборка нужных записей.
	$param['data'][] = "
	SELECT * FROM shop_city_table 
	LEFT JOIN shop_location_table 
	USING(shop_location_id) 
	WHERE shop_city_table.shop_location_id='$shop_location_id'
	{FILTER_STRING} {ORDER_STRING} {LIMIT}";

	// Число нужных записей.
	$count = "
	SELECT count(shop_city_id) AS count 
	FROM shop_city_table 
	WHERE shop_location_id='$shop_location_id'
	{FILTER_STRING}";

	// Формируем верхнее меню.
	$k = 0;
	$menu = array();
	$menu[$k]['name'] = $GLOBALS['MSG_shops']['citys'];
	$menu[$k]['link'] = '';
	$menu[$k]['icon'] = '';

	$p = 0;
	$sub_menu = array();
	$sub_menu[$p]['name'] = $GLOBALS['MSG_shops']['show_city_link1'];
	$sub_menu[$p]['link'] = $admin_forms->GetHtmlCallTrigerSingleAction('edit_city', 'check_0_0', 60, 0, 0);
	$sub_menu[$p]['onclick'] = $admin_forms->GetOnClickCallTrigerSingleAction('edit_city', 'check_0_0', 60, 0, 0);
	$sub_menu[$p]['icon'] = '/admin/images/city_add.gif';

	// Добавляем подэлементы.
	$menu[$k]['sub_items'] = $sub_menu;

	// Формируем массив меню.
	$menu_array = array();
	$menu_array[] = $menu;

	$param['total_count'][] = $count;
	$param['current_page'] = $page;
	$param['on_page'] = $on_page;
	$param['menus'] = $menu_array;

	return $param;
}

// Удаление города (вместе с районами)
function delete_city(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$shop = & singleton('shop');

		$count = 0;

		if (isset($param['data']))
		{
			foreach ($param['data'] as $dataset)
			{
				foreach ($dataset as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					$shop = & singleton('shop');

					// Определяем информацию об объекте
					$object_row = $shop->GetCity($key);

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						if (!$shop->DeleteCity($key))
						{
							$flag_success = false;
						}
						else
						{
							$count++;
							
							$flag_success = true;
						}
					}
					else
					{
						$user_access->MessageOnlyOwn();
						
						$flag_success = false;
					}
				}
			}

			if ($flag_success)
			{
				if ($count == 1)
				{
					show_message($GLOBALS['MSG_shops']['city_success_delete']);
				}
				else
				{
					show_message($GLOBALS['MSG_shops']['citys_success_delete']);
				}
			}
		}
	}
	$error = ob_get_clean();

	$param['error'] = $error;

}

// добавление/редактирование города
function edit_city(&$param)
{
	ob_start();

	$shop_groups_parent_id = to_int($_REQUEST['shop_groups_parent_id']);

	$shop_shops_id = to_int($_REQUEST['shop_shops_id']);

	if (isset($param['data']))
	{
		if (isset($param['data'][0]))
		{
			foreach ($param['data'][0] as $key => $value)
			{
				// Определяем режим доступа пользователя и принадлежит ли объект пользователю
				$user_access = new user_access();

				$shop = & singleton('shop');

				// Определяем информацию об объекте
				$object_row = $shop->GetCity($key);

				if ($object_row)
				{
					$object_user_id = $object_row['users_id'];
				}
				else
				{
					$object_user_id = 0;
				}

				if ($user_access->IssetUserAccessForObject($object_user_id))
				{
					$id = $key;

					include(CMS_FOLDER.'admin/shop/action/form_edit_add_city.php');

					// Устанавливаем <title> для страницы
					$param['title'] = ($id == 0) ? $GLOBALS['MSG_shops']['city_add_form_title']:$GLOBALS['MSG_shops']['city_add_form_title'];
				}
				else
				{
					$user_access->MessageOnlyOwn();
					$param['error'] = ob_get_clean();
					return ;
				}
			}

		}
	}

	$param['result'] = ob_get_clean();
	return true;
}

// применить изменения
function apply_change(&$param)
{
	ob_start();
	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$params = array();

		$db = & singleton('DataBase');

		if (isset($param['data']))
		{
			if (isset($param['data'][0]))
			{
				foreach ($param['data'][0] as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					$shop = & singleton('shop');

					// Определяем информацию об объекте
					$object_row = $shop->GetCity($key);

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						$val = to_int($value['shop_city_order']);

						$query = "UPDATE `shop_city_table` SET `shop_city_order` = '$val' WHERE `shop_city_id` = '$key'";

						$db->query($query);
					}
					else
					{
						$user_access->MessageOnlyOwn();
						$param['error'] = ob_get_clean();
						return ;
					}

				}
			}
		}
	}
	$error = ob_get_clean();

	$param['error'] = $error;
}

?>